// stylelint-disable declaration-no-important

.show-on-dark {
    display: none;
}

:root[data-theme=dark] {
    // Body
    //
    // Settings for the `<body>` element.

    $body-bg:                   $gray-900 !default;
    $body-color:                $white !default;

    body {
        background-color: $gray-900;
        color: $white;
    }

    #page.drawers {
        @include thin-scrolls($gray-800);
        .main-inner {
            background-color: $gray-900;
        }
    }


    // Links
    //
    // Style anchor elements.

    $link-color:                              theme-color("primary") !default;
    $link-hover-color:                        darken($link-color, 15%) !default;

    a {
        color: mix($white, $link-color, 60%);

        &:hover {
            color: mix($white, $link-hover-color, 60%);
        }

        &.focus,
        &:focus {
            color: inherit;
        }
    }

    // Accessible focus styling for links, add .aalink to links with custom css classes to get
    // accessible focus styles.
    .aalink,
    #page-footer a:not([class]),
    .arrow_link,
    a:not([class]),
    .activityinstance > a {
        &.focus,
        &:focus {
            color: $gray-100;
            background-color: mix($black, $primary, 50%);
            box-shadow: 0 -#{$btn-focus-width} mix($black, $primary, 50%), 0 $btn-focus-width $gray-800;
        }
        &:focus:hover {
            text-decoration: none;
        }
    }


    // Components
    //
    // Define common padding and border radius sizes and more.

    $border-color:                $gray-300 !default;
    $component-active-color:      $white !default;
    $component-active-bg:         theme-color("primary") !default;


    // Typography
    //
    // Font, line-height, and color for body text, headings, and more.

    $headings-color:              null !default;
    $blockquote-small-color:      $gray-600 !default;
    $hr-border-color:             rgba($black, .1) !default;
    $mark-bg:                     #fcf8e3 !default;

    hr {
        border-top-color: $gray-800;
    }


    // Tables
    //
    // Customizes the `.table` component with basic values, each used across all table variations.

    $table-color:                 $body-color !default;
    $table-accent-bg:             rgba($black, .05) !default;
    $table-hover-color:           $table-color !default;
    $table-hover-bg:              rgba($black, .075) !default;
    $table-active-bg:             $table-hover-bg !default;
    $table-border-color:          $border-color !default;
    $table-head-bg:               $gray-200 !default;
    $table-head-color:            $gray-700 !default;
    $table-dark-color:            $white !default;
    $table-dark-bg:               $gray-800 !default;
    $table-dark-accent-bg:        rgba($white, .05) !default;
    $table-dark-hover-color:      $table-dark-color !default;
    $table-dark-hover-bg:         rgba($white, .075) !default;
    $table-dark-border-color:     lighten($table-dark-bg, 7.5%) !default;


    // Moodle Tables

    .generaltable {
        color: $white;

        thead {
            th,
            td {
                border-bottom-color: $gray-800;
            }
        }

        th,
        td {
            border-top-color: $gray-800;
        }
    }


    // Buttons + Forms
    //
    // Shared variables that are reassigned to `$input-` and `$btn-` specific variables.

    $input-btn-focus-color:       rgba($component-active-bg, .25) !default;


    // Buttons
    //
    // For each of Bootstrap's buttons, define text, background, and border color.

    .btn {
        color: $white;

        &.btn-icon {
            &:hover,
            &:focus {
                background-color: $gray-600;
            }
        }
    }

    .btn-secondary {
        color: $white;
        background-color: $gray-600;
        border-color: $gray-600;

        &:hover {
            color: $white;
            background-color: darken($gray-600, 7.5%);
        }
    }

    .btn-outline-primary {
        color: mix($white, $link-color, 60%);
        border-color: mix($white, $link-color, 60%);

        &:hover {
            color: $white;
            border-color: $primary;
        }
        &:focus,
        &.focus {
            outline: $btn-focus-width solid $link-color;
        }
    }

    .btn-outline-secondary {
        color: $gray-600;
        border-color: $gray-600;

        &:hover {
            color: $white;
        }
    }

    .btn-outline-secondary:not(:disabled):not(.disabled):active,
    .btn-outline-secondary:not(:disabled):not(.disabled).active,
    .show > .btn-outline-secondary.dropdown-toggle {
        color: $white;
    }


    // Forms

    $input-bg:                              $white !default;
    $input-disabled-bg:                     $gray-200 !default;
    $input-color:                           $gray-700 !default;
    $input-border-color:                    $gray-400 !default;
    $input-focus-bg:                        $input-bg !default;
    $input-focus-border-color:              lighten($component-active-bg, 25%) !default;
    $input-placeholder-color:               $gray-600 !default;
    $input-group-addon-bg:                  $gray-200 !default;
    $custom-control-indicator-border-color: $gray-500 !default;
    $custom-control-label-disabled-color:           $gray-600 !default;
    $custom-select-disabled-color:      $gray-600 !default;
    $custom-select-disabled-bg:         $gray-200 !default;
    $custom-select-indicator-color:     $gray-800 !default;
    $custom-range-track-bg:             $gray-300 !default;
    $custom-range-thumb-disabled-bg:             $gray-500 !default;

    .form-control {
        background-color: $gray-900;
        color: $gray-300;
        border-color: $gray-600;

        &::placeholder {
            color: $gray-300;
        }
    }

    $dark-custom-select-indicator:           url("data:image/svg+xml,<svg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'><path fill='#{$gray-300}' d='M2 0L0 2h4zm0 5L0 3h4z'/></svg>") !default;
    .custom-select {
        background-color: $gray-900;
        // background-image: url("data:image/svg+xml;utf8,<svg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'><path fill='#{$gray-300}' d='M2 0L0 2h4zm0 5L0 3h4z'/></svg>");
        background-image: escape-svg($dark-custom-select-indicator);
        color: $gray-300;

        &:disabled {
            background-color: $gray-700;
            color: $gray-300;
        }
    }


    .custom-control-label {
        &::before {
            background-color: $gray-300;
        }
    }

    .custom-control-input {
        &:checked ~ .custom-control-label::before {
            background-color: $component-active-bg;
        }
    }

    // Form validation

    $form-feedback-valid-color:         theme-color("success") !default;
    $form-feedback-invalid-color:       theme-color("danger") !default;
    $form-feedback-icon-valid-color:    $form-feedback-valid-color !default;
    $form-feedback-icon-invalid-color:  $form-feedback-invalid-color !default;


    // Navs

    $nav-link-disabled-color:           $gray-600 !default;
    $nav-tabs-border-color:             $gray-300 !default;
    $nav-tabs-link-hover-border-color:  $gray-200 $gray-200 $nav-tabs-border-color !default;
    $nav-tabs-link-active-color:        $gray-700 !default;
    $nav-tabs-link-active-border-color: $gray-300 $gray-300 $nav-tabs-link-active-bg !default;
    $nav-pills-link-active-color:       $component-active-color !default;
    $nav-divider-color:                 $gray-200 !default;

    .nav-tabs .nav-link.active,
    .nav-tabs .nav-item.show .nav-link {
        color: $white;
        background-color: $gray-900;
        border-color: $gray-300 $gray-300 $primary;
    }


    // Navbar

    $navbar-dark-color:                 rgba($white, .5) !default;
    $navbar-dark-hover-color:           rgba($white, .75) !default;
    $navbar-dark-active-color:          $white !default;
    $navbar-dark-disabled-color:        rgba($white, .25) !default;
    $navbar-dark-toggler-border-color:  rgba($white, .1) !default;
    $navbar-light-color:                rgba($black, .5) !default;
    $navbar-light-hover-color:          rgba($black, .7) !default;
    $navbar-light-active-color:         rgba($black, .9) !default;
    $navbar-light-disabled-color:       rgba($black, .3) !default;
    $navbar-light-toggler-border-color: rgba($black, .1) !default;
    $navbar-light-brand-color:                $navbar-light-active-color !default;
    $navbar-light-brand-hover-color:          $navbar-light-active-color !default;
    $navbar-dark-brand-color:                 $navbar-dark-active-color !default;
    $navbar-dark-brand-hover-color:           $navbar-dark-active-color !default;

    .primary-navigation {
        .moremenu {
            .nav-link {
                &.active {
                    background-color: $dark;
                }
            }
        }
    }


    // Dropdowns
    //
    // Dropdown menu container and contents.

    $dropdown-bg:                       $white !default;
    $dropdown-color:                    $body-color !default;
    $dropdown-border-color:             rgba($black, .15) !default;
    $dropdown-divider-bg:               $gray-200 !default;
    $dropdown-link-color:               $gray-900 !default;
    $dropdown-link-hover-color:         darken($gray-900, 5%) !default;
    $dropdown-link-hover-bg:            $gray-200 !default;
    $dropdown-link-active-color:        $component-active-color !default;
    $dropdown-link-active-bg:           $component-active-bg !default;
    $dropdown-link-disabled-color:      $gray-500 !default;
    $dropdown-header-color:             $gray-600 !default;

    .dropdown-menu {
        background-color: $gray-900;
        border-color: $gray-800;
    }

    .dropdown-item {
        &:hover,
        &:focus,
        &.active,
        &:active,
        &:focus-within {
            color: $white;
        }
    }

    .dropdown-divider {
        border-top-color: $gray-800;
    }


    // Pagination

    $pagination-color:                  $link-color !default;
    $pagination-bg:                     $white !default;
    $pagination-border-color:           $gray-300 !default;
    $pagination-hover-color:            $link-hover-color !default;
    $pagination-hover-bg:               $gray-200 !default;
    $pagination-hover-border-color:     $gray-300 !default;
    $pagination-active-color:           $component-active-color !default;
    $pagination-active-border-color:    $pagination-active-bg !default;
    $pagination-disabled-color:         $gray-600 !default;
    $pagination-disabled-bg:            $white !default;
    $pagination-disabled-border-color:  $gray-300 !default;

    .page-link {
        background-color: $gray-900;
        border-color: $gray-800;
    }


    // Jumbotron

    $jumbotron-bg:                      $gray-200 !default;


    // Cards

    $card-border-color:                 rgba($black, .125) !default;
    $card-cap-bg:                       rgba($black, .03) !default;
    $card-cap-color:                    null !default;
    $card-color:                        null !default;
    $card-bg:                           $white !default;

    .card {
        background-color: $gray-900;
        border-color: rgba($white, .125);
    }

    .card-header {
        background-color: rgba($white, .03);
    }


    // Tooltips

    $tooltip-color:                     $white !default;
    $tooltip-bg:                        $black !default;
    $tooltip-arrow-color:               $tooltip-bg !default;

    .tooltip-inner {
        color: $white;
        background-color: $gray-900;
    }

    .bs-tooltip-top {
        .arrow {
            &::before {
                border-top-color: $gray-900;
            }
        }
    }

    .bs-tooltip-right {
        .arrow {
            &::before {
                border-right-color: $gray-900;
            }
        }
    }

    .bs-tooltip-bottom {
        .arrow {
            &::before {
                border-bottom-color: $gray-900;
            }
        }
    }

    .bs-tooltip-left {
        .arrow {
            &::before {
                border-left-color: $gray-900;
            }
        }
    }


    // Popovers

    $popover-bg:                        $white !default;
    $popover-border-color:              rgba($black, .2) !default;
    $popover-header-bg:                 darken($popover-bg, 3%) !default;
    $popover-header-color:              $headings-color !default;
    $popover-body-color:                $body-color !default;
    $popover-arrow-color:               $popover-bg !default;
    $popover-arrow-outer-color:         fade-in($popover-border-color, .05) !default;

    .popover {
        background-color: $gray-900;
        border-color: $gray-800;
    }

    .popover-header {
        color: $white;
        background-color: $gray-900;
    }

    .popover-body {
        color: $white;
    }

    .bs-popover-top {
        > .arrow {
            &::before {
                border-top-color: $gray-800;
            }

            &::after {
                border-top-color: $gray-900;
            }
        }
    }

    .bs-popover-right {
        > .arrow {
            &::before {
                border-right-color: $gray-800;
            }

            &::after {
                border-right-color: $gray-900;
            }
        }
    }

    .bs-popover-bottom {
        > .arrow {
            &::before {
                border-bottom-color: $gray-800;
            }

            &::after {
                border-bottom-color: $gray-900;
            }
        }
    }

    .bs-popover-left {
        > .arrow {
            &::before {
                border-left-color: $gray-800;
            }

            &::after {
                border-left-color: $gray-900;
            }
        }
    }


    // Popover Moodle

    .popover-region-container {
        background-color: $gray-900;
        border-color: $gray-800;
    }

    .popover-region-header-container {
        border-color: $gray-800;
    }

    .popover-region-footer-container {
        background-color: $gray-900;
        border-color: $gray-800;
    }

    .popover-region-toggle {
        &::before {
            border-bottom-color: $gray-800;
        }

        &::after {
            border-bottom-color: $gray-900;
        }
    }


    // Noficitaction Moodle

    .notification-area {
        border-color: $gray-800;

        .control-area {
            border-right-color: $gray-800;
        }
    }


    // Message Moodle

    .message-app {
        background-color: mix($white, $gray-900, 2%);

        .btn.btn-link.btn-icon {
            &:hover,
            &:focus {
                background-color: $gray-600;
            }
        }
    }


    // Toasts

    $toast-background-color:            rgba($white, .85) !default;
    $toast-border-color:                rgba(0, 0, 0, .1) !default;
    $toast-header-color:                $gray-600 !default;
    $toast-header-background-color:     rgba($white, .85) !default;
    $toast-header-border-color:         rgba(0, 0, 0, .05) !default;


    // Modals

    $modal-content-bg:                  $white !default;
    $modal-content-border-color:        rgba($black, .2) !default;
    $modal-header-border-color:         $border-color !default;
    $modal-backdrop-bg:                 $black !default;

    .modal-content {
        background-color: $gray-900;
    }

    .modal-header {
        border-bottom-color: $gray-800;
    }

    .modal-footer {
        border-top-color: $gray-800;
    }

    .modchooser .modal-footer {
        background-color: $gray-900;
    }


    // Progress bars

    $progress-bg:                       $gray-200 !default;
    $progress-bar-color:                $white !default;


    // List group

    $list-group-color:                  null !default;
    $list-group-bg:                     $white !default;
    $list-group-border-color:           rgba($black, .125) !default;
    $list-group-hover-bg:               $gray-100 !default;
    $list-group-active-color:           $component-active-color !default;
    $list-group-active-bg:              $component-active-bg !default;
    $list-group-active-border-color:    $list-group-active-bg !default;
    $list-group-disabled-color:         $gray-600 !default;
    $list-group-disabled-bg:            $list-group-bg !default;
    $list-group-action-color:           $gray-700 !default;
    $list-group-action-hover-color:     $list-group-action-color !default;
    $list-group-action-active-color:    $body-color !default;
    $list-group-action-active-bg:       $gray-200 !default;

    .list-group-item {
        background-color: $gray-900;
        border-color: rgba($white, .125);
    }


    // Image thumbnails

    $thumbnail-bg:                      $body-bg !default;
    $thumbnail-border-color:            $gray-300 !default;


    // Figures

    $figure-caption-color:              $gray-600 !default;


    // Breadcrumbs

    $breadcrumb-bg:                     $gray-200 !default;
    $breadcrumb-divider-color:          $gray-600 !default;
    $breadcrumb-active-color:           $gray-600 !default;


    // Carousel

    $carousel-control-color:             $white !default;
    $carousel-caption-color:             $white !default;
    $carousel-indicator-active-bg:       $white !default;


    // Close

    $close-color:                       $black !default;

    .close {
        color: $white;
    }


    // Code

    $code-color:                        $pink !default;
    $kbd-color:                         $white !default;
    $kbd-bg:                            $gray-900 !default;
    $pre-color:                         $gray-900 !default;


    .sr-only-focusable {
        &:active,
        &:focus {
            background: $black;
        }
    }

    .block .block-cards {
        .course-summaryitem {
            border: $border-width solid $border-color;
            background-color: $gray-900;
        }
        span.categoryname,
        .btn-link {
            color: $white;

            &.btn-icon {
                &:hover,
                &:focus {
                    background-color: $gray-800;
                }
            }
        }
    }

    .block .block-controls {
        .dropdown-toggle {
            color: $white;
        }
    }

    .drawer {
        background-color: mix($white, $gray-900, 2%);

        .icon {
            filter: brightness(0) invert(1);
        }
    }

    .drawer-toggles .drawer-toggler .btn {
        background-color: $gray-800;
    }

    .secondary-navigation .navigation {
        background-color: $gray-900;
        border-bottom-color: $gray-800;
    }

    .moremenu {
        .nav-tabs {
            background-color: $gray-900;
        }

        .nav-link {
            &:focus,
            &:hover {
                background-color: $gray-800;
            }

            &.active {
                background-color: $gray-900;
                &:focus,
                &:hover {
                    background-color: $gray-800;
                }
            }
        }
    }

    #region-main {
        background-color: $gray-900;
    }

    div.category[data-categoryid] a {
        color: mix(color-yiq($gray-900), $primary, 50%);
        border-color: mix(color-yiq($gray-900), $primary, 50%);
    }

    div.category[data-categoryid] a:focus {
        color: lighten(mix(color-yiq($gray-900), $primary, 50%), 10%);
        background-color: rgba(mix(color-yiq($gray-900), $primary, 50%), .2);
        outline: .2rem solid mix(color-yiq($gray-900), $primary, 50%);
        box-shadow: none;
    }

    @each $category, $fac-color in $categories {
        $color: mix(color-yiq($gray-900), $fac-color, 50%);
        div.category[data-categoryid="#{$category}"] a {
            color: $color;
            border-color: $color;
        }

        div.category[data-categoryid="#{$category}"] a:focus {
            color: lighten($color, 10%);
            background-color: rgba($color, .2);
            outline: .2rem solid $color;
            box-shadow: none;
        }
    }

    .courseindex .courseindex-item,
    .courseindex .courseindex-item .courseindex-link,
    .courseindex .courseindex-item .courseindex-chevron {
        color: $gray-300;

        @include hover-focus() {
            color: $gray-100;
        }
    }

    .course-section {
        border-bottom-color: $gray-800;
    }

    // Activity

    .activityiconcontainer.other:not(.isbranded) .activityicon:not(.nofilter),
    .activityiconcontainer.other:not(.isbranded) .icon:not(.nofilter) {
        filter: invert(1);
    }

    .activity-item {
        background-color: $gray-900;
        border-color: $gray-800;
    }

    .activity-item:not(.activityinline) {
        border-color: $gray-800;
    }

    .activity-dates {
        color: $gray-400;
    }

    .path-mod .activity-header:not(:empty) {
        background-color: $gray-800;
    }

    .activity-add,
    .block-add {
        background-color: mix($black, $primary, 80%);
    }

    .editing .activity-item {
        &:hover {
            color: $white;
            background-color: mix($black, $primary, 80%);

            .description .course-description-item,
            .activityiconcontainer,
            .badge {
                mix-blend-mode: normal;
            }
        }
    }

    .modchoosercontainer .optionscontainer .option .optioninfo a,
    .modchoosercontainer .searchresultitemscontainer .option .optioninfo a {
        color: $gray-300;
    }

    .modchoosercontainer .optionscontainer .option .optionactions .optionaction,
    .modchoosercontainer .searchresultitemscontainer .option .optionactions .optionaction {
        color: $gray-400;
    }

    .modchooser .modal-body .optionsummary {
        background-color: $gray-900;
    }

    #page-mod-quiz-edit {
        ul.slots li.section {
            .content {
                background-color: mix($white, $gray-900, 4%);
            }

            li.activity {
                background-color: $gray-800;

                &.page {
                    background: transparent;
                }

                .instancemaxmarkcontainer {
                    background-color: $gray-900;
                }
            }
        }

        #categoryquestions .questionname,
        ul.slots li.activity div.activityinstance .questionname,
        ul.slots li.activity div.activityinstance .questiontext {
            color: $white;
        }

        .slotnumber {
            background-color: $gray-700;
        }

        .section .activity .actions {
            background-color: $gray-800;
        }
    }

    .que .info {
        background-color: $gray-800;
        border-color: $gray-700;
    }

    .que .formulation {
        @include alert-variant(
            theme-color-level('info', $alert-bg-level + 18),
            theme-color-level('info', $alert-border-level),
            theme-color-level('info', $alert-color-level - 18)
        );
    }

    .path-mod-quiz #mod_quiz_navblock .qnbutton {
        background-color: $gray-800;

        &.thispage .thispageholder {
            border-color: $gray-500;
        }

        &.notyetanswered .trafficlight,
        &.invalidanswer .trafficlight {
            background-color: $gray-800;
        }
    }

    img.icon {
        filter: brightness(1) invert(1);
    }

    .simplesearchform .btn-submit {
        background-color: $gray-700;
    }

    .block_rss_client .list li {
        border-top-color: $gray-800;
    }

    .bg-pulse-grey {
        animation: bg-pulse-dark 2s infinite linear;
    }

    @keyframes bg-pulse-dark {
        0% {
            background-color: $gray-800;
        }
        50% {
            background-color: darken($gray-800, 5%);
        }
        100% {
            background-color: $gray-800;
        }
    }

    // Not great but easier than removing that classe everywhere
    .bg-white {
        background-color: $gray-900 !important;
    }
    .bg-light {
        background-color: $gray-800 !important;
    }

    .text-muted {
        color: $gray-400 !important;
    }

    .border-bottom {
        border-bottom-color: $gray-800 !important;
    }

    .show-on-dark {
        display: inherit;
    }

    .hide-on-dark {
        display: none;
    }
}